import YZLocalStorage from '@youzan/utils/browser/local_storage';
import ajax from '../../../common/ajax';
export default {
  requestAreaList: function requestAreaList(url) {
    var _this = this;

    return new Promise(function (resolve, reject) {
      var localAdressData; // localStorage中有地址数据

      try {
        localAdressData = JSON.parse(YZLocalStorage.getItem('cap_address_area_data'));
      } catch (e) {}

      if (localAdressData && localAdressData.province_list) {
        resolve(localAdressData);
        return;
      }

      var dataType = url.slice(-5) === 'jsonp' ? 'jsonp' : 'json';
      ajax({
        method: 'GET',
        url: url,
        dataType: dataType
      }).then(function (res) {
        if (+res.code === 0) {
          var areaList = res.data || {};
          YZLocalStorage.setItem('cap_address_area_data', JSON.stringify(_this.curAreaList));
          resolve(areaList);
        }
      }).catch(function (res) {
        reject(res);
      });
    });
  }
};