import commonAjax from '../../../common/ajax';
export default function ajax(url, options) {
  if (options === void 0) {
    options = {};
  }

  if (typeof url === 'object') {
    url.withCredentials = true;
  } else {
    options.withCredentials = true;
  }

  var promise = commonAjax(url, options);
  return promise.then(function (res) {
    if (res && +res.code === 0) {
      return Promise.resolve(res.data);
    }

    return Promise.reject(res);
  }, function () {
    return Promise.reject({
      code: -1,
      msg: '网络出了点问题，请稍后重试'
    });
  });
}