import "vant/es/toast/style";
import _Toast from "vant/es/toast";
import ajax from '../../../common/ajax';

function Token(tokenUrl) {
  this.loadingLock = false;
  this.tokenUrl = tokenUrl;
  this.isUsed = undefined;
}

Token.prototype = {
  fetch: function fetch() {
    if (this.isUsed === false) {
      return;
    }

    var _this = this;

    _this.loadingLock = true;
    ajax({
      url: _this.tokenUrl,
      type: 'GET',
      dataType: 'jsonp'
    }).then(function (res) {
      if (+res.code === 0) {
        _this.token = res.data;
        _this.loadingLock = false;
        _this.isUsed = false;
      } else {
        _Toast(res.msg);
      }
    }, function () {
      _Toast('token 获取失败');
    });
  },
  get: function get() {
    this.isUsed = true;
    return this.token;
  }
};
export default Token;