import rawAjax from '../../../common/ajax';
/**
 * 封装ajax请求
 * @param {Object} options 请求参数
 * @return {Promise}
 */

export function ajaxData(options) {
  return rawAjax(options).then(function (resp) {
    if (resp.code !== 0) {
      return Promise.reject(resp.msg);
    }

    return Promise.resolve(resp.data);
  }).catch(function (error) {
    if (typeof error === 'string') return Promise.reject(error);
    return Promise.reject(error.message || error.msg || '系统错误');
  });
}