import Pay from './pay/index.js';
import PayManager from './pay-manager/index.js';
import PaySet from './pay-set/index.js';
import Area from './area/index.js';
import AreaPicker from './area-picker/index.js';
import Ajax from './ajax/index.js';
import Address from './address/index.js';
import OrderList from './order-list/index.js';
import OrderAction from './order-action/index.js';
import Store from './store/index.js';
import ImageAd from './image-ad/index.js';
import ImgUploader from './img-uploader/index.js';
import IdcardUploader from './idcard-uploader/index.js';
import GoodsList from './goods-list/index.js';
import TagList from './tag-list/index.js';
import TagListTop from './tag-list-top/index.js';
import ShopNav from './shop-nav/index.js';
import Showcase from './showcase/index.js';
import Login from './login/index.js';
import LoginDialog from './login-dialog/index.js';
import UserGrade from './user-grade/index.js';
import MemberCard from './member-card/index.js';
import GiftCard from './gift-card/index.js';
import RechargeButton from './recharge-button/index.js';
import Entry from './entry/index.js';
import RichText from './rich-text/index.js';
import Title from './title/index.js';
import TextNav from './text-nav/index.js';
import ImageNav from './image-nav/index.js';
import Line from './line/index.js';
import White from './white/index.js';
import Component from './component/index.js';
import Coupon from './coupon/index.js';
import InvalidGoods from './invalid-goods/index.js';
import ExpressWay from './express-way/index.js';
import Logistics from './logistics/index.js';
import Captcha from './captcha/index.js';
import ImageCaptcha from './image-captcha/index.js';
import BehaviorCaptcha from './behavior-captcha/index.js';
import OrderGoods from './order-goods/index.js';
import ShowcaseAudio from './showcase-audio/index.js';
import Cube from './cube/index.js';
import CubeOld from './cube-old/index.js';
import UmpActivity from './ump-activity/index.js';
import UmpSeckill from './ump-seckill/index.js';
import UmpGroupon from './ump-groupon/index.js';
import UmpTimelimitedDiscount from './ump-timelimited-discount/index.js';
import PaidMember from './paid-member/index.js';
import PaidContent from './paid-content/index.js';
import PaidColumn from './paid-column/index.js';
import OrderCoupon from './order-coupon/index.js';
import MemberCoupon from './member-coupon/index.js';
import ShopBanner from './shop-banner/index.js';
import ShopTopNav from './shop-top-nav/index.js';
import Takeout from './takeout/index.js';
import WgwNav from './wgw-nav/index.js';
import GetCoupon from './get-coupon/index.js';
import ShopTopLink from './shop-top-link/index.js';
import TplGuidePage from './tpl-guide-page/index.js';
import ScrollNav from './scroll-nav/index.js';
import Scroll from './scroll/index.js';
import UmpPeriodbuy from './ump-periodbuy/index.js';
import GoodsLayout from './goods-layout/index.js';
import Wx from './wx/index.js';
import Countdown from './countdown/index.js';
import AudioController from './audio-controller/index.js';
import OfflineShopInfo from './offline-shop-info/index.js';
import ContactUs from './contact-us/index.js';
import Unicashier from './unicashier/index.js';
import RelatedLink from './related-link/index.js';
import ShopBannerWxd from './shop-banner-wxd/index.js';
import Text from './text/index.js';
import Slider from './slider/index.js';
import PromoCode from './promo-code/index.js';
import Placeholder from './placeholder/index.js';
import FilterBar from './filter-bar/index.js';
import FilterItem from './filter-item/index.js';
import Tabs from './tabs/index.js';
import Category from './category/index.js';
import PayCashierWsc from './pay-cashier-wsc/index.js';
import MobileAuth from './mobile-auth/index.js';
import MobileSupply from './mobile-supply/index.js';
import CertIdOcr from './cert-id-ocr/index.js';
import CertSteps from './cert-steps/index.js';
import CertNotice from './cert-notice/index.js';
import CertBankView from './cert-bank-view/index.js';
import CertRecognition from './cert-recognition/index.js';
import CertImageUploader from './cert-image-uploader/index.js';
var components = [Pay, PaySet, Area, AreaPicker, Ajax, Address, OrderList, Store, ImageAd, ImgUploader, IdcardUploader, GoodsList, TagList, TagListTop, ShopNav, Showcase, Login, LoginDialog, UserGrade, MemberCard, GiftCard, RechargeButton, Entry, RichText, Title, TextNav, ImageNav, Line, White, Component, Coupon, InvalidGoods, ExpressWay, Logistics, Captcha, ImageCaptcha, BehaviorCaptcha, OrderGoods, ShowcaseAudio, Cube, CubeOld, UmpActivity, UmpSeckill, UmpGroupon, UmpTimelimitedDiscount, PaidMember, PaidContent, PaidColumn, OrderCoupon, MemberCoupon, ShopBanner, ShopTopNav, Takeout, WgwNav, GetCoupon, ShopTopLink, TplGuidePage, ScrollNav, Scroll, UmpPeriodbuy, GoodsLayout, Countdown, AudioController, OfflineShopInfo, ContactUs, Unicashier, RelatedLink, ShopBannerWxd, Text, Slider, PromoCode, Placeholder, FilterBar, FilterItem, Tabs, Category, PayCashierWsc, MobileAuth, MobileSupply, CertIdOcr, CertSteps, CertNotice, CertBankView, CertRecognition, CertImageUploader];

var install = function install(Vue) {
  if (install.installed) return;
  components.forEach(function (component) {
    component && component.name && Vue.component(component.name, component);
  });
}; // auto install


if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

var version = '2.0.5';
export default {
  install: install,
  version: version
};
export { install, version, Pay, PayManager, PaySet, Area, AreaPicker, Ajax, Address, OrderList, OrderAction, Store, ImageAd, ImgUploader, IdcardUploader, GoodsList, TagList, TagListTop, ShopNav, Showcase, Login, LoginDialog, UserGrade, MemberCard, GiftCard, RechargeButton, Entry, RichText, Title, TextNav, ImageNav, Line, White, Component, Coupon, InvalidGoods, ExpressWay, Logistics, Captcha, ImageCaptcha, BehaviorCaptcha, OrderGoods, ShowcaseAudio, Cube, CubeOld, UmpActivity, UmpSeckill, UmpGroupon, UmpTimelimitedDiscount, PaidMember, PaidContent, PaidColumn, OrderCoupon, MemberCoupon, ShopBanner, ShopTopNav, Takeout, WgwNav, GetCoupon, ShopTopLink, TplGuidePage, ScrollNav, Scroll, UmpPeriodbuy, GoodsLayout, Wx, Countdown, AudioController, OfflineShopInfo, ContactUs, Unicashier, RelatedLink, ShopBannerWxd, Text, Slider, PromoCode, Placeholder, FilterBar, FilterItem, Tabs, Category, PayCashierWsc, MobileAuth, MobileSupply, CertIdOcr, CertSteps, CertNotice, CertBankView, CertRecognition, CertImageUploader };