import "vant/es/toast/style";
import _Toast from "vant/es/toast";
import _extends from "@babel/runtime/helpers/esm/extends";
import aes from '@youzan/yz-aes';
import ajax from '../utils/ajax';
import PageMixin from '../mixins/page-mixin';
export default {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      staticClass: "cap-login__form cap-login__login"
    }, [_c('van-cell-group', [_vm.showCountrySelect ? _c('vm-form-item', {
      attrs: {
        "title": "国家",
        "is-link": ""
      },
      on: {
        "click": _vm.doSelectCountry
      }
    }, [_vm._v("\n      " + _vm._s(_vm.country.name) + " " + _vm._s(_vm.country.code) + "\n    ")]) : _vm._e(), _c('vm-form-item', {
      attrs: {
        "title": "手机号"
      }
    }, [_c('vm-input', {
      attrs: {
        "type": "tel",
        "placeholder": "请输入手机号"
      },
      model: {
        value: _vm.loginData.phone,
        callback: function callback($$v) {
          _vm.$set(_vm.loginData, "phone", $$v);
        },
        expression: "loginData.phone"
      }
    })], 1), _c('vm-form-item', {
      attrs: {
        "title": "密码"
      }
    }, [_c('vm-password', {
      attrs: {
        "placeholder": "请输入密码"
      },
      model: {
        value: _vm.loginData.password,
        callback: function callback($$v) {
          _vm.$set(_vm.loginData, "password", $$v);
        },
        expression: "loginData.password"
      }
    })], 1)], 1), _c('vm-actions', [_c('template', {
      slot: "button"
    }, [_c('van-button', {
      attrs: {
        "type": "danger",
        "block": ""
      },
      on: {
        "click": _vm.handleSubmit
      }
    }, [_vm._v("\n        登录\n      ")])], 1), _c('template', {
      slot: "tips"
    }, [_c('span', {
      on: {
        "click": _vm.handleForgetPasswordClick
      }
    }, [_vm._v("忘记密码？")]), _c('span', {
      staticClass: "cap-login--pull-right",
      on: {
        "click": _vm.goRegister
      }
    }, [_vm._v("\n        去注册\n      ")])])], 2)], 1);
  },
  mixins: [PageMixin],
  props: {
    source: String,
    loginUrl: String,
    loginRedirectUrl: String,
    loginErrorCallback: Function
  },
  data: function data() {
    return {
      loginData: {
        phone: this.phone || '',
        password: '',
        source: this.source
      }
    };
  },
  methods: {
    handleSubmit: function handleSubmit() {
      var _this = this;

      this.$emit('logger', {
        type: 'login'
      });
      var phoneReg = /^\d{1,20}$/;

      var loginData = _extends({}, this.loginData);

      var phone = loginData.phone;

      if (!phone) {
        _Toast('请输入手机号');

        return;
      }

      if (!phoneReg.test(phone)) {
        _Toast('手机号格式不正确');

        return;
      }

      if (!loginData.password) {
        _Toast('请输入密码');

        return;
      }

      loginData.password = aes.encrypt(loginData.password);
      ajax({
        url: this.loginUrl,
        method: 'POST',
        data: _extends({}, loginData, {
          country_code: this.country.code
        })
      }).then(function () {
        location.href = _this.loginRedirectUrl;
      }, function (res) {
        var loginErrorCallback = _this.loginErrorCallback;

        if (loginErrorCallback) {
          loginErrorCallback(res);
        } else {
          _Toast(res.msg || '登录失败');
        }
      });
    },
    handleForgetPasswordClick: function handleForgetPasswordClick() {
      this.$emit('typeChange', 'forget-password');
    },
    goRegister: function goRegister() {
      this.$emit('typeChange', 'register-phone');
    }
  }
};