import "vant/es/icon/style";
import _Icon from "vant/es/icon";
import "vant/es/cell-group/style";
import _CellGroup from "vant/es/cell-group";
import "vant/es/cell/style";
import _Cell from "vant/es/cell";
import "vant/es/button/style";
import _Button from "vant/es/button";
import Actions from '../components/actions';
import FormItem from '../components/form-item';
import Input from '../components/input';
import Password from '../components/password';
import Captcha from '../../../captcha/index';
export default {
  components: {
    'van-button': _Button,
    'van-cell': _Cell,
    'van-cell-group': _CellGroup,
    'van-icon': _Icon,
    'vm-actions': Actions,
    'vm-form-item': FormItem,
    'vm-input': Input,
    'vm-password': Password,
    'vm-captcha': Captcha
  },
  props: {
    phone: [String, Number],
    country: {
      type: Object,
      default: function _default() {
        return {
          code: '+86',
          name: '中国'
        };
      }
    },
    showCountrySelect: {
      type: Boolean,
      default: true
    }
  },
  watch: {
    'loginData.phone': function loginDataPhone(val) {
      this.$emit('phoneChange', val);
    }
  },
  methods: {
    doSelectCountry: function doSelectCountry() {
      this.$emit('showCountry');
    }
  }
};