import "vant/es/cell-group/style";
import _CellGroup from "vant/es/cell-group";
import "vant/es/cell/style";
import _Cell from "vant/es/cell";

var _components;

import { getTotalPrice } from '../utils';
export default {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('van-cell-group', {
      staticClass: "cap-order-goods-price__detail"
    }, [_c('van-cell', {
      staticClass: "cap-order-goods-price__detail__total",
      attrs: {
        "title": "总计",
        "value": _vm.onlyTotalPrice
      }
    }), _c('van-cell', {
      staticClass: "cap-order-goods-price__detail__item-group"
    }, _vm._l(_vm.itemList, function (item, key) {
      return _c('p', {
        key: key
      }, [_c('span', {
        staticClass: "cap-order-goods-price__detail__item"
      }, [_vm._v("\n        " + _vm._s(item.goods_date) + "\n      ")]), _c('span', {
        staticClass: "cap-order-goods-price__detail__item cap-order-goods-price__detail__item--right"
      }, [_vm._v("\n        " + _vm._s(_vm.getPayPrice(item.pay_price)) + " "), _c('i', [_vm._v(_vm._s(_vm.getNum(item.num)))])])]);
    }), 0)], 1);
  },
  name: 'cap-order-goods-price-detail',
  components: (_components = {}, _components[_Cell.name] = _Cell, _components[_CellGroup.name] = _CellGroup, _components),
  props: {
    price: Number,
    itemList: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  },
  computed: {
    onlyTotalPrice: function onlyTotalPrice() {
      return getTotalPrice(this.price);
    }
  },
  methods: {
    getPayPrice: function getPayPrice(payPrice) {
      return '¥' + (payPrice / 100).toFixed(2);
    },
    getNum: function getNum(num) {
      return 'x' + num;
    }
  }
};