import Waterfall from '@vant/waterfall';
import Vue from 'vue';
import OrderItem from './item';
Waterfall.install(Vue);
export default {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      directives: [{
        name: "waterfall-lower",
        rawName: "v-waterfall-lower",
        value: _vm.loadMore,
        expression: "loadMore"
      }],
      staticClass: "cap-order-list",
      attrs: {
        "waterfall-disabled": "disabled"
      }
    }, [_vm._t("default", _vm._l(_vm.orders, function (item, index) {
      return _c('cap-order-item', {
        key: item.id,
        attrs: {
          "order": item
        },
        on: {
          "btnclick": function btnclick($event) {
            _vm.onBtnClick(index, $event);
          },
          "itemclick": function itemclick($event) {
            _vm.onItemClick(index, $event);
          }
        }
      });
    }))], 2);
  },
  name: 'cap-order-list',
  components: {
    'cap-order-item': OrderItem
  },
  props: {
    loadMoreOrder: {
      type: Function,
      validator: function validator(value) {
        return typeof value === 'function';
      }
    },
    orders: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    loadMore: function loadMore() {
      this.loadMoreOrder();
    },
    onBtnClick: function onBtnClick(index, event) {
      this.$emit('btnclick', event.type, event.order, index);
    },
    onItemClick: function onItemClick(index, event) {
      this.$emit('itemclick', event.order, index);
    }
  }
};