/* eslint-disable camelcase */
import ajax from '../../../common/ajax';
export default {
  requestPayWithPayWay: function requestPayWithPayWay(url, cashierData, payWayData) {
    return ajax({
      url: url,
      method: 'POST',
      data: {
        payDataJson: cashierData,
        payTool: payWayData.payChannel,
        value_card_no: payWayData.value_card_no,
        password: payWayData.password || ''
      }
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      return resp.data;
    });
  },
  requestPay: function requestPay(url, postData) {
    return ajax({
      method: 'POST',
      data: postData,
      url: this.payRequestUrl
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      return resp.data;
    });
  },
  requestCashier: function requestCashier(url, cashierData) {
    return ajax({
      method: 'POST',
      data: cashierData,
      url: url
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      return resp.data;
    });
  },
  requestQrcodePay: function requestQrcodePay(url, postData) {
    return ajax({
      url: url,
      method: 'POST',
      data: postData
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      var data = resp.data || {};
      return data.content || '';
    });
  },
  requestPayStatus: function requestPayStatus(url, postData) {
    return ajax({
      url: url,
      method: 'POST',
      data: postData
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      var data = resp.data || {};
      return data.status || '';
    });
  }
};