## RichText 富文本

### 使用指南
```javascript
import { RichText } from 'captain-showcase';

Vue.use(RichText);
```

### 代码演示

```html
<div v-lazy-container="{ selector: '.js-richtext-lazy-img' }">
  <cap-rich-text :content="content" :fullscreen="true" />
</div>
```

```js
export default {
  data() {
    return {
      content: '<img src="http://pic.58pic.com/58pic/16/62/63/97m58PICyWM_1024.jpg" /><iframe class="edui-faked-video" src="https://v.qq.com/iframe/player.html?vid=o0026ni108p&amp;tiny=0&amp;auto=0" width="300" height="225" allowfullscreen="true"></iframe><img data-origin-width="640" data-origin-height="427" src="https://img.yzcdn.cn/upload_files/2018/03/08/8877ec6a1d87fdaae8a3e72c2b44ef72.jpg!730x0.jpg">'
    };
  }
};
```

### API

| 参数       | 说明      | 类型       | 默认值       | 可选值       |
|-----------|-----------|-----------|-------------|-------------|
| content | 富文本内容 | `string`  | `''`  |  |
| fullscreen | 是否全屏显示 | `boolean`  | `false`  | |
| color | 背景颜色 | `string`  | `'#ffffff'`  |  |
| is-preview | 是否预览模式，预览模式不转换html内容 | `boolean`  | `false`  |  |
| url-map | 可配置url列表 | `object`  | 通用url列表  |  |
