import WechatNav from './components/wechat-nav';
import App1Nav from './components/app1-nav';
import App2Nav from './components/app2-nav';
import App3Nav from './components/app3-nav';
import { NAV_STYLE_MAP } from './constants';
export default {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      staticClass: "cap-shop-nav",
      class: ["cap-shop-nav--" + _vm.navStyle]
    }, [+_vm.navStyle === 1 ? [_c('wechat-nav', {
      attrs: {
        "home-url": _vm.homeUrl,
        "navs": _vm.navs
      }
    })] : +_vm.navStyle === 2 ? [_c('app1-nav', {
      attrs: {
        "background-color": _vm.backgroundColor,
        "navs": _vm.navs,
        "use-icon": _vm.useIcon
      }
    })] : +_vm.navStyle === 3 ? [_c('app2-nav', {
      attrs: {
        "background-color": _vm.backgroundColor,
        "navs": _vm.navs,
        "main-navs": _vm.mainNavs
      }
    })] : [_c('app3-nav', {
      attrs: {
        "navs": _vm.navs,
        "main-navs": _vm.mainNavs,
        "nav-style": _vm.navStyle
      }
    })]], 2);
  },
  name: 'cap-shop-nav',
  components: {
    'wechat-nav': WechatNav,
    'app1-nav': App1Nav,
    'app2-nav': App2Nav,
    'app3-nav': App3Nav
  },
  props: {
    navStyle: {
      type: [String, Number],
      default: NAV_STYLE_MAP.wechat
    },
    navs: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    mainNavs: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    backgroundColor: String,
    color: String,
    activeColor: String,
    homeUrl: String,
    useIcon: Boolean
  }
};