<script>
export default {
  data() {
    return {
      textAlign: 'center',
      color: '#333',
      text: '我是文本',
      linkUrl: 'https://youzan.com',
      fontSize: 14,
      bgColor: '#fff',
    }
  }
};
</script>

## Text 文本

### 使用指南
#### 使用 [babel-plugin-import](https://github.com/ant-design/babel-plugin-import) (推荐)
```javascript
import { Text } from 'captain-ui';
```

### 代码演示

#### 基础用法

:::demo
```html
<cap-text 
  :text="text" 
  :text-align="textAlign" 
  :color="color" 
  :link-url="linkUrl" 
  :font-size="fontSize"
  :bg-color="bgColor"
  show-split-line
>
</cap-text>
<cap-text 
  :text="text" 
  :text-align="textAlign" 
  :color="color" 
  :link-url="linkUrl" 
  :font-size="fontSize" 
  :bg-color="bgColor">
</cap-text>

<script>
export default {
  data() {
    return {
      textAlign: 'center',
      color: '#333',
      text: '我是文本',
      linkUrl: 'https://youzan.com',
      fontSize: 14,
      bgColor: '#fff',
    }
  }
};
</script>
```
:::

### API

| 参数       | 说明      | 类型       | 默认值       | 可选值      |
|-----------|-----------|-----------|-------------|-------------|
| text | 文本内容 | `String`  | `` |  |
| textAlign | 文本内容对齐方式 | `String`  | `left` |  |
| bgColor | 文本背景色 | `String`  | `` |  |
| color | 文字颜色 | `String`  | `` |  |
| fontSize | 文字大小 | `String`  | `` |  |
| lineHeight | 文字行高 | `String` | `` |  |
| linkUrl | 跳转链接 | `String`  | `` |  |

