"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _local_storage = _interopRequireDefault(require("@youzan/utils/browser/local_storage"));

var _ajax = _interopRequireDefault(require("../../../common/ajax"));

var _default = {
  requestAreaList: function requestAreaList(url) {
    var _this = this;

    return new Promise(function (resolve, reject) {
      var localAdressData; // localStorage中有地址数据

      try {
        localAdressData = JSON.parse(_local_storage.default.getItem('cap_address_area_data'));
      } catch (e) {}

      if (localAdressData && localAdressData.province_list) {
        resolve(localAdressData);
        return;
      }

      var dataType = url.slice(-5) === 'jsonp' ? 'jsonp' : 'json';
      (0, _ajax.default)({
        method: 'GET',
        url: url,
        dataType: dataType
      }).then(function (res) {
        if (+res.code === 0) {
          var areaList = res.data || {};

          _local_storage.default.setItem('cap_address_area_data', JSON.stringify(_this.curAreaList));

          resolve(areaList);
        }
      }).catch(function (res) {
        reject(res);
      });
    });
  }
};
exports.default = _default;