"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/toast/style");

var _toast = _interopRequireDefault(require("vant/es/toast"));

var _ajax = _interopRequireDefault(require("../../../common/ajax"));

function Token(tokenUrl) {
  this.loadingLock = false;
  this.tokenUrl = tokenUrl;
  this.isUsed = undefined;
}

Token.prototype = {
  fetch: function fetch() {
    if (this.isUsed === false) {
      return;
    }

    var _this = this;

    _this.loadingLock = true;
    (0, _ajax.default)({
      url: _this.tokenUrl,
      type: 'GET',
      dataType: 'jsonp'
    }).then(function (res) {
      if (+res.code === 0) {
        _this.token = res.data;
        _this.loadingLock = false;
        _this.isUsed = false;
      } else {
        (0, _toast.default)(res.msg);
      }
    }, function () {
      (0, _toast.default)('token 获取失败');
    });
  },
  get: function get() {
    this.isUsed = true;
    return this.token;
  }
};
var _default = Token;
exports.default = _default;