"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.ajaxData = ajaxData;

var _ajax = _interopRequireDefault(require("../../../common/ajax"));

/**
 * 封装ajax请求
 * @param {Object} options 请求参数
 * @return {Promise}
 */
function ajaxData(options) {
  return (0, _ajax.default)(options).then(function (resp) {
    if (resp.code !== 0) {
      return Promise.reject(resp.msg);
    }

    return Promise.resolve(resp.data);
  }).catch(function (error) {
    if (typeof error === 'string') return Promise.reject(error);
    return Promise.reject(error.message || error.msg || '系统错误');
  });
}