"use strict";

exports.__esModule = true;
exports.delay = exports.getVideoURL = void 0;

var getVideoURL = function getVideoURL(source) {
  var url = null; // file转换成blob

  if (window.createObjectURL !== undefined) {
    // basic
    url = window.createObjectURL(source);
  } else if (window.URL !== undefined) {
    // mozilla(firefox)
    url = window.URL.createObjectURL(source);
  } else if (window.webkitURL !== undefined) {
    // webkit or chrome
    url = window.webkitURL.createObjectURL(source);
  }

  return url;
};

exports.getVideoURL = getVideoURL;

var delay = function delay(ts) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ts);
  });
};

exports.delay = delay;