"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.WxAppPayError = exports.WxPayBridgeError = exports.WxPayError = exports.AjaxError = exports.ZanError = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var ZanError =
/*#__PURE__*/
function (_Error) {
  (0, _inheritsLoose2.default)(ZanError, _Error);

  function ZanError(message) {
    var _this;

    _this = _Error.call(this, message) || this;
    _this.name = 'ZanError';
    return _this;
  }

  return ZanError;
}((0, _wrapNativeSuper2.default)(Error));

exports.ZanError = ZanError;

var AjaxError =
/*#__PURE__*/
function (_ZanError) {
  (0, _inheritsLoose2.default)(AjaxError, _ZanError);

  function AjaxError(resp) {
    var _this2;

    _this2 = _ZanError.call(this, resp.msg) || this;
    _this2.name = 'AjaxError';
    _this2.data = resp.data;
    _this2.resp = resp;
    return _this2;
  }

  return AjaxError;
}(ZanError);

exports.AjaxError = AjaxError;

var WxPayError =
/*#__PURE__*/
function (_ZanError2) {
  (0, _inheritsLoose2.default)(WxPayError, _ZanError2);

  function WxPayError(resp, payData) {
    var _this3;

    _this3 = _ZanError2.call(this, resp.err_desc) || this;
    _this3.name = 'WxPayError';
    _this3.payData = payData;
    _this3.resp = resp;
    return _this3;
  }

  return WxPayError;
}(ZanError);

exports.WxPayError = WxPayError;

var WxPayBridgeError =
/*#__PURE__*/
function (_ZanError3) {
  (0, _inheritsLoose2.default)(WxPayBridgeError, _ZanError3);

  function WxPayBridgeError(resp) {
    var _this4;

    _this4 = _ZanError3.call(this, resp.msg) || this;
    _this4.name = 'WxPayBridgeError';
    return _this4;
  }

  return WxPayBridgeError;
}(ZanError);

exports.WxPayBridgeError = WxPayBridgeError;

var WxAppPayError =
/*#__PURE__*/
function (_ZanError4) {
  (0, _inheritsLoose2.default)(WxAppPayError, _ZanError4);

  function WxAppPayError(resp) {
    var _this5;

    _this5 = _ZanError4.call(this, resp.msg) || this;
    _this5.name = 'WxAppPayError';
    _this5.msg = resp.msg;
    _this5.retry = !!resp.retry;
    _this5.resp = resp;
    return _this5;
  }

  return WxAppPayError;
}(ZanError);

exports.WxAppPayError = WxAppPayError;