"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _create = _interopRequireDefault(require("../utils/create"));

var _default = (0, _create.default)({
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      staticClass: "cap-line-wrap",
      style: _vm.wrapStyle
    }, [_c('hr', {
      staticClass: "cap-line",
      style: _vm.borderStyle
    })]);
  },
  name: 'line',
  props: {
    lineType: {
      type: String,
      default: ''
    },
    color: {
      type: String,
      default: ''
    },
    hasPadding: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    wrapStyle: function wrapStyle() {
      return this.hasPadding ? {
        padding: '0 15px'
      } : {};
    },
    borderStyle: function borderStyle() {
      return this.lineType && this.color ? {
        borderTop: "1px " + this.lineType + " " + this.color
      } : {};
    }
  }
});

exports.default = _default;