"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _inputMixin = _interopRequireDefault(require("../../../common/mixins/input-mixin"));

var _default = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      directives: [{
        name: "clickoutside",
        rawName: "v-clickoutside",
        value: _vm.doCloseFocus,
        expression: "doCloseFocus"
      }],
      staticClass: "cap-login__password"
    }, [_vm.passwordShow ? [_c('input', {
      attrs: {
        "type": "text",
        "placeholder": _vm.placeholder
      },
      domProps: {
        "value": _vm.currentValue
      },
      on: {
        "focus": function focus($event) {
          _vm.isFocus = true;
        },
        "input": _vm.handleInput
      }
    }), _c('van-icon', {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.isFocus && _vm.currentValue,
        expression: "isFocus && currentValue"
      }],
      attrs: {
        "name": "password-view"
      },
      on: {
        "click": function click($event) {
          _vm.passwordShow = !_vm.passwordShow;
        }
      }
    })] : [_c('input', {
      attrs: {
        "type": "password",
        "placeholder": _vm.placeholder
      },
      domProps: {
        "value": _vm.currentValue
      },
      on: {
        "focus": function focus($event) {
          _vm.isFocus = true;
        },
        "input": _vm.handleInput
      }
    }), _c('van-icon', {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.isFocus && _vm.currentValue,
        expression: "isFocus && currentValue"
      }],
      attrs: {
        "name": "password-not-view"
      },
      on: {
        "click": function click($event) {
          _vm.passwordShow = !_vm.passwordShow;
        }
      }
    })]], 2);
  },
  mixins: [_inputMixin.default],
  props: {
    value: String,
    placeholder: String
  },
  data: function data() {
    return {
      passwordShow: false
    };
  }
};
exports.default = _default;