"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/toast/style");

var _toast = _interopRequireDefault(require("vant/es/toast"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _yzAes = _interopRequireDefault(require("@youzan/yz-aes"));

var _ajax = _interopRequireDefault(require("../utils/ajax"));

var _pageMixin = _interopRequireDefault(require("../mixins/page-mixin"));

var _default = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      staticClass: "cap-login__form cap-login__register-captcha"
    }, [_c('van-cell-group', [_c('vm-form-item', {
      attrs: {
        "title": "密码"
      }
    }, [_c('vm-password', {
      attrs: {
        "placeholder": "请输入密码"
      },
      model: {
        value: _vm.loginData.password,
        callback: function callback($$v) {
          _vm.$set(_vm.loginData, "password", $$v);
        },
        expression: "loginData.password"
      }
    })], 1), _c('vm-form-item', {
      staticClass: "cap-login__captcha-item",
      attrs: {
        "title": "验证码"
      }
    }, [_c('vm-captcha', {
      attrs: {
        "placeholder": "请输入验证码",
        "captcha-url": _vm.captchaUrl,
        "image-captcha-url": _vm.imageCaptchaUrl,
        "check-image-captcha-url": _vm.checkImageCaptchaUrl,
        "token-url": _vm.tokenUrl,
        "phone": _vm.phone,
        "country": _vm.country
      },
      on: {
        "statusChange": _vm.handleCaptchaStatusChange
      },
      model: {
        value: _vm.loginData.code,
        callback: function callback($$v) {
          _vm.$set(_vm.loginData, "code", $$v);
        },
        expression: "loginData.code"
      }
    })], 1)], 1), _c('p', {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.captchaStatus === 'disabled',
        expression: "captchaStatus === 'disabled'"
      }],
      staticClass: "cap-login__tip"
    }, [_vm._v("\n    验证码已发送至手机号 " + _vm._s(_vm.country.code) + " " + _vm._s(_vm.phone) + "\n  ")]), _c('vm-actions', [_c('template', {
      slot: "button"
    }, [_c('van-button', {
      attrs: {
        "type": "danger",
        "block": ""
      },
      on: {
        "click": _vm.handleSubmit
      }
    }, [_vm._v("\n        完成注册\n      ")])], 1)], 2)], 1);
  },
  mixins: [_pageMixin.default],
  props: {
    registerUrl: String,
    captchaUrl: String,
    imageCaptchaUrl: String,
    checkImageCaptchaUrl: String,
    tokenUrl: String,
    source: String
  },
  data: function data() {
    return {
      loginData: {
        code: '',
        password: ''
      },
      captchaStatus: ''
    };
  },
  methods: {
    handleSubmit: function handleSubmit() {
      var _this = this;

      var source = this.source;
      var loginData = (0, _extends2.default)({}, this.loginData);

      if (!loginData.password) {
        (0, _toast.default)('请输入密码');
        return;
      }

      if (!loginData.code) {
        (0, _toast.default)('请输入验证码');
        return;
      }

      loginData.password = _yzAes.default.encrypt(loginData.password);
      (0, _ajax.default)({
        url: this.registerUrl,
        method: 'POST',
        data: (0, _extends2.default)({}, loginData, {
          phone: this.phone,
          country_code: this.country && this.country.code,
          source: source
        })
      }).then(function () {
        _this.$emit('typeChange', 'login');
      }, function (res) {
        (0, _toast.default)(res.msg || '网络错误');
      });
    },
    handleCaptchaStatusChange: function handleCaptchaStatusChange(status) {
      this.captchaStatus = status;
    }
  }
};
exports.default = _default;