"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/toast/style");

var _toast = _interopRequireDefault(require("vant/es/toast"));

require("vant/es/button/style");

var _button = _interopRequireDefault(require("vant/es/button"));

require("vant/es/popup/style");

var _popup = _interopRequireDefault(require("vant/es/popup"));

require("vant/es/icon/style");

var _icon = _interopRequireDefault(require("vant/es/icon"));

var _ajax = _interopRequireDefault(require("../../common/ajax.js"));

var _default = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('van-popup', {
      staticClass: "cap-mobile-auth-container",
      attrs: {
        "value": _vm.value
      }
    }, [_c('span', {
      staticClass: "cap-mobile-auth-container__close",
      on: {
        "click": _vm.onCloseClicked
      }
    }, [_vm._v("\n    ×\n  ")]), _c('h3', [_vm._v("手机号授权")]), _c('img', {
      staticClass: "logo",
      attrs: {
        "src": _vm.imgShopUrl,
        "width": "36",
        "height": "36"
      }
    }), _c('p', {
      staticClass: "name"
    }, [_vm._v(_vm._s(_vm.nameShop))]), _c('div', {
      staticClass: "cap-mobile-auth-container__hr"
    }), _vm.nameApp ? _c('p', {
      staticClass: "desc"
    }, [_vm._v("\n    申请获取你在" + _vm._s(_vm.nameApp) + "绑定的手机号\n  ")]) : _c('p', {
      staticClass: "desc"
    }, [_vm._v("\n    申请获取你的手机号\n  ")]), _c('p', {
      staticClass: "mobile"
    }, [_vm._v(_vm._s(_vm.phone.slice(0, 3) + '****' + _vm.phone.slice(7, _vm.phone.length)))]), _c('van-button', {
      attrs: {
        "size": "large",
        "type": "primary"
      },
      on: {
        "click": _vm.next
      }
    }, [_vm._v("\n    确认授权\n  ")]), _c('p', {
      staticClass: "extra"
    }, [_vm._v("授权即代表同意"), _c('a', {
      attrs: {
        "href": "https://bbs.youzan.com/forum.php?mod=viewthread&tid=672890&page=1&extra=#pid3837866"
      }
    }, [_vm._v("《有赞用户使用协议》")])])], 1);
  },
  name: 'cap-mobile-auth',
  components: {
    'van-icon': _icon.default,
    'van-popup': _popup.default,
    'van-button': _button.default
  },
  props: {
    value: {
      type: Boolean,
      default: false
    },
    phone: {
      type: String,
      default: ''
    },
    imgShopUrl: {
      type: String,
      default: ''
    },
    nameShop: {
      type: String,
      default: ''
    },
    nameApp: {
      type: String,
      default: ''
    },
    kdtId: {
      type: Number,
      defalut: 0
    },
    onSuccess: {
      type: Function,
      default: null
    }
  },
  data: function data() {
    return {
      name: 'World'
    };
  },
  methods: {
    onCloseClicked: function onCloseClicked() {
      this.$emit('input', false);
    },
    next: function next() {
      var _this = this;

      var requestData = {
        mobile: this.phone,
        kdtId: this.kdtId
      };
      (0, _ajax.default)({
        method: 'POST',
        data: requestData,
        url: 'https://passport.youzan.com/mobile-authentication/mobile-auth.json',
        rawResponse: true,
        withCredentials: true
      }).then(function (res) {
        if (res.code === 0) {
          if (_this.onSuccess) {
            _this.onSuccess();
          }

          _this.onCloseClicked();
        } else {
          (0, _toast.default)(res.msg);
        }
      }).catch(function (err) {
        console.log(err);
      });
    }
  }
};
exports.default = _default;