"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/toast/style");

var _toast = _interopRequireDefault(require("vant/es/toast"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _vue = _interopRequireDefault(require("vue"));

var _ajax = _interopRequireDefault(require("../../../common/ajax"));

var _config = _interopRequireDefault(require("../config"));

var _FailGoodsDialog = _interopRequireDefault(require("./FailGoodsDialog"));

/* eslint-disable camelcase */
var instance;

var alertFailGoods = function alertFailGoods(goods) {
  if (!instance) {
    instance = new (_vue.default.extend(_FailGoodsDialog.default))({
      el: document.createElement('div')
    });
    instance.$on('input', function (value) {
      instance.value = value;
    });
    document.body.appendChild(instance.$el);
  }

  return new Promise(function (resolve, reject) {
    return (0, _extends2.default)(instance, {
      value: true,
      goods: goods,
      resolve: resolve,
      reject: reject
    });
  });
};

var BuyAgain =
/*#__PURE__*/
function () {
  function BuyAgain(options) {
    if (options === void 0) {
      options = {};
    }

    this.url = options.url || _config.default.BUY_AGAIN.BUY_AGAIN_URL;
    this.cartUrl = options.cartUrl || _config.default.BUY_AGAIN.CART_URL;
    this.data = options.data || {};
    this.orderNo = this.data.order_no || '';
    this.kdtId = this.data.kdt_id || '';
    this.goodsList = this.data.goodsList || [];
    this.callback = options.callback;
    this.isBuying = false;
    /* this.unsupportBuyAgainIntance = options.unsupportBuyAgainIntance; */
  }

  var _proto = BuyAgain.prototype;

  _proto.buyAgain = function buyAgain() {
    var _this = this;

    (0, _ajax.default)({
      url: this.url,
      method: 'POST',
      data: {
        order_no: this.orderNo,
        kdt_id: this.kdtId
      }
    }).then(function (resp) {
      if (resp.code === 0) {
        var data = Array.isArray(resp.data) ? resp.data : [];
        var cartUrl = _this.cartUrl + '?kdt_id=' + _this.kdtId; // 返回的数据是添加到购物车失败的商品数组，全部成功时返回空数组

        if (data.length === 0) {
          _this._saveSessionStorage(_this.goodsList, _this.kdtId);

          window.location.href = cartUrl;
        } else {
          // 商品sku与数量信息需要从订单商品列表中获取，然后构造一个新的数组
          var parsedGoodsList = _this._buildGoodsList(_this.goodsList, data);

          _this._saveSessionStorage(parsedGoodsList.successList, _this.kdtId);

          alertFailGoods(parsedGoodsList.failList).then(function () {
            // 商品全部添加失败时直接隐藏弹层，不跳转
            if (_this.goodsList.length === data.length) {// 关闭什么都不做
            } else {
              window.location.href = cartUrl;
            }
          });
        }
      } else {
        (0, _toast.default)(resp.msg);
      }
    }).catch(function () {
      (0, _toast.default)('再来一单请求失败。');
    });
  };

  _proto._saveSessionStorage = function _saveSessionStorage(goodsList, kdtId) {
    try {
      var parsedList = goodsList.map(function (goods) {
        var goods_id = goods.goods_id,
            sku_id = goods.sku_id,
            num = goods.num,
            _goods$activity_id = goods.activity_id,
            activity_id = _goods$activity_id === void 0 ? 0 : _goods$activity_id;
        return {
          goods_id: goods_id,
          sku_id: sku_id,
          num: num,
          activity_id: activity_id
        };
      });
      window.sessionStorage.setItem('buyAgain', JSON.stringify({
        kdtId: kdtId,
        goodsList: parsedList
      }));
    } catch (e) {
      console.log('e');
    }
  };

  _proto._buildGoodsList = function _buildGoodsList(goodsList, failGoodsList) {
    var failList = failGoodsList.map(function (failGoods) {
      var goodsArr = goodsList.filter(function (goods) {
        return goods.sku_id === failGoods.sku_id && goods.goods_id === failGoods.goods_id;
      });
      var findedGoods = goodsArr[0] || {};
      var sku = findedGoods.sku.map(function (item) {
        return item.v;
      }).join(' ');
      return {
        title: findedGoods.title || findedGoods.goods_info.title || '',
        num: findedGoods.num,
        sku: sku
      };
    });
    var successList = goodsList.filter(function (goods) {
      return !failGoodsList.some(function (failGoods) {
        return goods.sku_id === failGoods.sku_id && goods.goods_id === failGoods.goods_id;
      });
    });
    return {
      failList: failList,
      successList: successList
    };
  };

  return BuyAgain;
}();

var _default = BuyAgain;
exports.default = _default;