"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/cell-group/style");

var _cellGroup = _interopRequireDefault(require("vant/es/cell-group"));

require("vant/es/cell/style");

var _cell = _interopRequireDefault(require("vant/es/cell"));

var _header = _interopRequireDefault(require("./components/header"));

var _empty = _interopRequireDefault(require("./components/empty"));

var _message = _interopRequireDefault(require("./components/message"));

var _price = _interopRequireDefault(require("./components/price"));

var _card = _interopRequireDefault(require("./components/card"));

var _components;

var _default2 = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('van-cell-group', {
      staticClass: "cap-order-goods"
    }, [_vm.shopName ? _c('cap-order-goods-header', {
      attrs: {
        "title": _vm.shopName,
        "link": _vm.shopLink,
        "icon": _vm.headerIcon,
        "badge": _vm.headerBadge
      }
    }) : _vm._e(), _vm._t("top"), _vm.isEmpty ? _c('cap-order-goods-empty', {
      attrs: {
        "icon": _vm.emptyIcon,
        "message": _vm.emptyMessage,
        "button-text": _vm.emptyButtonText
      },
      on: {
        "back": function back($event) {
          _vm.$emit('back');
        }
      }
    }) : _vm._e(), _c('div', {
      staticClass: "cap-order-goods-list"
    }, [_vm._t("card", _vm._l(_vm.itemList, function (item, index) {
      return _c('cap-order-goods-card', {
        key: item.title + index,
        attrs: {
          "data": item,
          "disable-message-view": _vm.disableMessageView
        },
        on: {
          "change": function change(time) {
            return _vm.$emit('change', time, index);
          },
          "action:refund": _vm.onClickRefund,
          "action:review": _vm.onClickReview,
          "show-message-list": function showMessageList($event) {
            _vm.$emit('show-message-list', $event);
          }
        }
      });
    }))], 2), _vm._t("default"), !_vm.isEmpty ? [_vm.showMessage ? _c('cap-order-goods-message', {
      attrs: {
        "message": _vm.message,
        "editable": _vm.messageEditable
      },
      on: {
        "change": _vm.onMessageChange,
        "focus": function focus($event) {
          _vm.$emit('focus-message');
        }
      }
    }) : _vm._e(), _vm.showTotalPrice ? _c('cap-order-goods-price', {
      attrs: {
        "price": _vm.price,
        "points": _vm.points,
        "item-list": _vm.itemList,
        "show-price-detail": _vm.showPriceDetail
      }
    }) : _vm._e()] : _vm._e(), _vm._t("bottom")], 2);
  },
  name: 'cap-order-goods',
  components: (_components = {}, _components[_empty.default.name] = _empty.default, _components[_header.default.name] = _header.default, _components[_message.default.name] = _message.default, _components[_price.default.name] = _price.default, _components[_card.default.name] = _card.default, _components[_cell.default.name] = _cell.default, _components[_cellGroup.default.name] = _cellGroup.default, _components),
  model: {
    prop: 'message'
  },
  props: {
    shopName: String,
    shopLink: String,
    message: String,
    price: Number,
    points: Number,
    headerBadge: String,
    disableMessageView: Boolean,
    headerIcon: {
      type: String,
      default: 'shop'
    },
    emptyIcon: {
      type: String,
      default: 'https://b.yzcdn.cn/v2/image/wap/trade/new_order/empty@2x.png'
    },
    emptyMessage: {
      type: String,
      default: '哎呀，当前没有可购买的商品，请重新选择'
    },
    emptyButtonText: {
      type: String,
      default: '返回重新选择'
    },
    showMessage: {
      type: Boolean,
      default: true
    },
    showTotalPrice: {
      type: Boolean,
      default: true
    },
    showPriceDetail: {
      type: Boolean,
      default: false
    },
    messageEditable: {
      type: Boolean,
      default: true
    },
    itemList: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  },
  computed: {
    isEmpty: function isEmpty() {
      return this.itemList.length === 0;
    }
  },
  methods: {
    onMessageChange: function onMessageChange(message) {
      this.$emit('input', message);
    },
    onClickRefund: function onClickRefund(itemId) {
      this.$emit('action:refund', itemId);
    },
    onClickReview: function onClickReview(itemId) {
      this.$emit('action:review', itemId);
    }
  }
};
exports.default = _default2;