"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _ajax = _interopRequireDefault(require("../../../common/ajax"));

/* eslint-disable camelcase */
var _default = {
  requestPayWithPayWay: function requestPayWithPayWay(url, cashierData, payWayData) {
    return (0, _ajax.default)({
      url: url,
      method: 'POST',
      data: {
        payDataJson: cashierData,
        payTool: payWayData.payChannel,
        value_card_no: payWayData.value_card_no,
        password: payWayData.password || ''
      }
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      return resp.data;
    });
  },
  requestPay: function requestPay(url, postData) {
    return (0, _ajax.default)({
      method: 'POST',
      data: postData,
      url: this.payRequestUrl
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      return resp.data;
    });
  },
  requestCashier: function requestCashier(url, cashierData) {
    return (0, _ajax.default)({
      method: 'POST',
      data: cashierData,
      url: url
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      return resp.data;
    });
  },
  requestQrcodePay: function requestQrcodePay(url, postData) {
    return (0, _ajax.default)({
      url: url,
      method: 'POST',
      data: postData
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      var data = resp.data || {};
      return data.content || '';
    });
  },
  requestPayStatus: function requestPayStatus(url, postData) {
    return (0, _ajax.default)({
      url: url,
      method: 'POST',
      data: postData
    }).then(function (resp) {
      if (resp.code !== 0) {
        return Promise.reject(resp);
      }

      var data = resp.data || {};
      return data.status || '';
    });
  }
};
exports.default = _default;