"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/toast/style");

var _toast = _interopRequireDefault(require("vant/es/toast"));

require("vant/es/icon/style");

var _icon = _interopRequireDefault(require("vant/es/icon"));

require("vant/es/field/style");

var _field = _interopRequireDefault(require("vant/es/field"));

require("vant/es/button/style");

var _button = _interopRequireDefault(require("vant/es/button"));

var _yzAes = _interopRequireDefault(require("@youzan/yz-aes"));

var _url = _interopRequireDefault(require("../../../common/url"));

var _default2 = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('div', {
      staticClass: "cap-password"
    }, [_c('div', {
      staticClass: "cap-password__header"
    }, [_vm._v("\n    安全验证\n    "), _c('van-icon', {
      staticClass: "cap-password__close",
      attrs: {
        "name": "close"
      },
      on: {
        "click": _vm.close
      }
    })], 1), _c('div', {
      staticClass: "cap-password__input-container"
    }, [_c('p', [_vm._v("为了保障你的账户安全，请输入手机帐号" + _vm._s(_vm.secureAccount) + "的登录密码")]), _c('van-field', {
      staticClass: "cap-password__input-container__input van-hairline--surround",
      attrs: {
        "type": "password",
        "placeholder": "请输入登录密码"
      },
      on: {
        "blur": _vm.onFieldBlur
      },
      model: {
        value: _vm.passwordValue,
        callback: function callback($$v) {
          _vm.passwordValue = $$v;
        },
        expression: "passwordValue"
      }
    })], 1), _c('div', {
      staticClass: "cap-password__action-container"
    }, [_c('van-button', {
      attrs: {
        "block": "",
        "type": 'primary',
        "loading": _vm.loading
      },
      on: {
        "click": _vm.onPayClick
      }
    }, [_vm._v("\n      付款\n    ")])], 1), _c('div', {
      staticClass: "cap-password__bottom-tips"
    }, [_c('a', {
      attrs: {
        "href": _vm.changePasswordUrl
      }
    }, [_vm._v("忘记密码?")])])]);
  },
  name: 'cap-password',
  components: {
    'van-button': _button.default,
    'van-field': _field.default,
    'van-icon': _icon.default
  },
  props: {
    close: {
      type: Function,
      default: function _default() {}
    },
    account: {
      type: String,
      default: ''
    },
    payWay: Object,
    onConfirm: {
      type: Function,
      default: function _default() {}
    },
    loading: {
      type: Boolean,
      default: false
    },
    changePasswordUrl: {
      type: String,
      default: _url.default.wap + '/buyer/auth/changePassword?redirect_uri=' + encodeURIComponent(window.location.href)
    }
  },
  data: function data() {
    var account = this.account.toString();
    var secureAccount = account.slice(0, -8) + '****' + account.slice(-4);
    return {
      passwordValue: '',
      secureAccount: secureAccount
    };
  },
  methods: {
    onPayClick: function onPayClick() {
      if (!this.passwordValue) return (0, _toast.default)('请输入密码');
      this.onConfirm(_yzAes.default.encrypt(this.passwordValue));
    },
    onFieldBlur: function onFieldBlur() {
      // IOS12 & 微信环境6.7.4以后版本，webview的在fixed ,input下丢失焦点的问题
      window.scrollTo(0, 0);
    }
  }
};
exports.default = _default2;