"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

require("vant/es/cell/style");

var _cell = _interopRequireDefault(require("vant/es/cell"));

require("vant/es/loading/style");

var _loading = _interopRequireDefault(require("vant/es/loading"));

var _payConfig = _interopRequireDefault(require("../config/pay-config"));

var _default2 = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return !_vm.loading ? _c('div', {
      staticClass: "cap-pay-item",
      class: [{
        'cap-pay-item--disabled': !_vm.payWay.available
      }, _vm.highlightClass],
      style: {
        color: _vm.highlightColor
      },
      on: {
        "click": _vm.onPayClick
      }
    }, [_c('div', {
      staticClass: "cap-pay-item__wrapper"
    }, [_c('p', {
      staticClass: "cap-pay-item__content"
    }, [_vm._v(_vm._s(_vm.payWayDesc))]), _vm.extraDesc ? _c('p', {
      staticClass: "cap-pay-item__light"
    }, [_vm._v("\n      " + _vm._s(_vm.extraDesc) + "\n    ")]) : _vm._e()])]) : _c('div', {
      staticClass: "cap-pay-item"
    }, [_c('van-loading', {
      staticClass: "cap-pay-item__loading"
    })], 1);
  },
  name: 'van-payitem',
  components: {
    'van-loading': _loading.default,
    'van-cell': _cell.default
  },
  props: {
    payWay: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    loading: {
      type: Boolean,
      default: false
    },
    onClick: {
      type: Function,
      validate: function validate(value) {
        return typeof value === 'function';
      }
    }
  },
  data: function data() {
    // 支付方式显示
    var payWayDesc = this.payWay.pay_channel_name;
    return {
      payWayDesc: payWayDesc,
      extraDesc: this.payWay.available_desc ? '（' + this.payWay.available_desc + '）' : ''
    };
  },
  computed: {
    highlightColor: function highlightColor() {
      var highlightData = _payConfig.default[this.payWay.pay_channel] || {};
      return highlightData.color || '';
    },
    highlightClass: function highlightClass() {
      var highlightData = _payConfig.default[this.payWay.pay_channel] || {};
      return this.highlightColor ? '' : highlightData.className || '';
    }
  },
  methods: {
    onPayClick: function onPayClick() {
      if (!this.payWay.available) return;
      this.onClick(this.payWay);
    }
  }
};
exports.default = _default2;