"use strict";

exports.__esModule = true;
exports.default = void 0;

function after(newNode, targetNode) {
  return targetNode.parentNode.insertBefore(newNode, targetNode.nextSibling);
}

function setViewport() {
  var e = parseInt(window.screen.width);
  var t = e / 640;
  var i = navigator.userAgent;
  var viewportMeta = document.head.querySelector('meta[name=viewport]');
  var content;

  if (/Android (\d+\.\d+)/.test(i)) {
    var a = parseFloat(RegExp.$1);

    if (a > 2.3) {
      content = "width=640,minimum-scale=" + t + ",maximum-scale=" + t + ",target-densitydpi=device-dpi";
    } else {
      content = 'width=640, target-densitydpi=device-dpi';
    }
  } else {
    content = 'width=640, user-scalable=no, target-densitydpi=device-dpi';
  }

  if (!viewportMeta) {
    var target = document.head.firstElementChild;
    var newMeta = document.createElement('meta');
    newMeta.name = 'viewport';
    newMeta.content = content;
    after(newMeta, target);
  } else {
    viewportMeta.setAttribute('content', content);
  }
}

var _default = setViewport;
exports.default = _default;