"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _index = _interopRequireDefault(require("../../goods-layout/index"));

var _GoodsItem = _interopRequireDefault(require("./components/GoodsItem"));

var _constant = require("./constant");

var _components;

var _default2 = {
  render: function render() {
    var _vm = this;

    var _h = _vm.$createElement;

    var _c = _vm._self._c || _h;

    return _c('cap-goods-layout', {
      attrs: {
        "type": _vm.type,
        "is-show-more": _vm.isShowViewMore,
        "view-more-url": _vm.viewMoreUrl
      }
    }, _vm._l(_vm.goodsList, function (goods, index) {
      return _c('goods-item', {
        key: goods.id + "-" + index,
        attrs: {
          "type": _vm.type,
          "goods": goods,
          "base-url": _vm.baseUrl,
          "show-title": _vm.showTitle,
          "show-desc": _vm.showDesc,
          "show-buy-btn": _vm.showBuyBtn,
          "hide-goods-end": _vm.hideGoodsEnd,
          "buy-btn-type": _vm.buyBtnType,
          "ratio": _vm.ratio,
          "image-fill-style": _vm.imageFillStyle,
          "is-preview": _vm.isPreview
        }
      });
    }), 1);
  },
  name: 'cap-ump-periodbuy',
  components: (_components = {}, _components[_index.default.name] = _index.default, _components[_GoodsItem.default.name] = _GoodsItem.default, _components),
  props: {
    goodsList: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    size: {
      type: Number,
      default: 0
    },
    baseUrl: {
      type: String,
      default: 'https://h5.youzan.com/v2'
    },
    isShowViewMore: Boolean,
    showTitle: {
      type: Number,
      default: 1
    },
    showDesc: {
      type: Number,
      default: 1
    },
    showBuyBtn: {
      type: Number,
      default: 1
    },
    buyBtnType: {
      type: Number,
      default: 1
    },
    hideGoodsEnd: {
      type: Number,
      default: 1
    },
    isPreview: {
      type: Boolean,
      default: false
    },
    ratio: {
      type: String,
      default: '1,1'
    },
    imageFillStyle: {
      type: Number,
      default: 1
    }
  },
  computed: {
    type: function type() {
      return _constant.SIZEMAP[this.size];
    },
    viewMoreUrl: function viewMoreUrl() {
      return this.isPreview ? '' : this.baseUrl + "/ump/periodbuy/list";
    }
  }
};
exports.default = _default2;